<?php
require_once ALI_APPLICATION_PATH . '/controllers/Abstract/Metabox.php';

class Ali_Controller_MetaboxController
    extends Ali_Controller_Abstract_Metabox
{
    public function indexAction()
    {
        $post = $this->getParam(0);
        $postId = $post->ID;

        $form = Ali_Application::getForm('Metabox')
            ->setPost($post)
            ->load();

        $errors = array();

        $meta = Ali_Application::getModel('PostMeta')->setPostId($postId);
        $formErrors = $meta->getValue('errors');
        if ($formErrors && is_array($formErrors)) {
            $errors = array_unique(array_merge($errors, $formErrors));
        }
        $meta->unsetValue('errors');

        $this->_view->form = $form;
        $this->_view->post = $post;
        $this->_view->postId = $postId;
        $this->_view->errors = $errors;
    }

    public function handleSavePostAction()
    {
        $this->setViewScript(NULL);

        $postId = $this->getParam(0);
        $post = get_post($postId);
        $data = $this->getParam(1);

        $form = Ali_Application::getForm('Metabox')
            ->setPost($post)
            ->load();

        $errors = array();
        try {
            if ($form->isValid($data)) {
                $form->save();
            } else {
                foreach ($form->getElements() as $element) {
                    foreach ($element->getMessages() as $message) {
                        $errors[] = "{$element->getLabel()}: {$message}";
                    }
                }
            }
        } catch (Ali_Model_Amazon_Exception $e) {
            $errors[] = $e->getMessage();
        }

        $meta = Ali_Application::getModel('PostMeta')->setPostId($postId);
        if ($errors) {
            $meta->setValue('errors', $errors);
        } else {
            $meta->unsetValue('errors');
        }
    }
}