<?php

/*
Plugin Name: vxcvxcv
Plugin URI: 
Description: xcvxcvx
Author: tttt-dddd
Version: 1.1.5
Author URI: http://sdfsdf.com
Tested up to: 3.7
*/

/**
* Version history:
* 1.1.5:
*   force usage of PluginUpdateChecker v1.3
* 1.1.4:
*   new update logic for less server load
* 1.1.3:
*   new update URL
* 1.1.2:
*   bugfixes
* 1.1:
*   allow customization of max link count per post/page
* 1.0.6:
*   handle installation errors
* 1.0.5:
*   allow network activation
* 1.0.4:
*   added: embedded auto-update
* 1.0.3:
*   fixed: WP 3.5 incompatibility: remove "media" post type
* 1.0.2:
*   fixed 7H7-Y8X-QEEH: StringLength validator might fail with unusual
*       iconv encoding settings
* 1.0.1:
*   added: HTML of redirect page to solve the issue with caching plug-in
*/

require_once dirname(__FILE__) . '/library/compatibility.php';

//Register plug-in:
Ali_WpPlugin::init();

class Ali_WpPlugin
{
//------------------------------------------------------------------------------
// Static members
//------------------------------------------------------------------------------
    /**
    * Version tag. Used for CSS & JS versioning.
    */
    const VERSION = '01.01.05';

    /**
    * Unique slug
    */
    const SLUG = 'vxcvxcv';
    const ADMIN_SLUG = 'vxcvxcv';

    /**
    * Unique prefix
    */
    const PREFIX = 'ali';

    /**
    * User-friendly title
    */
    const TITLE = 'vxcvxcv';

    /**
    * Menu item text
    */
    const MENU_LABEL = 'vxcvxcv';

    /**
    * Required capability to access plug-in pages
    */
    const CAPABILITY = 'publish_posts';

    static protected $_instance;

    static protected $_pluginBaseUrl;
    static protected $_pluginPath;

    static protected $_keywordSlug;

    static protected $_updater;
    static protected $_updaterCronHook;
    const UPDATE_CHECK_UNTERVAL = 12;

    /**
    * Registers plug-in module
    */
    static public function init()
    {
        // Auto update
        require dirname(__FILE__) . '/plugin-updates/plugin-update-checker.php';
        self::$_updater = new PluginUpdateChecker_1_3(
            'http://127.0.0.1/dev/wp_auto_update/r/24/info.json',
            __FILE__,
            'vxcvxcv',
            0
        );
        self::$_updaterCronHook = 'auto_check_updates-' . self::SLUG;
        add_action(self::$_updaterCronHook, array(self::$_updater, 'checkForUpdates'));

        self::$_pluginBaseUrl = trailingslashit(get_bloginfo('wpurl')) . PLUGINDIR
            . '/' . dirname(plugin_basename(__FILE__));

        self::$_pluginPath = dirname(__FILE__);

        $class = get_class();

        register_activation_hook(__FILE__, array($class, 'activate'));
        register_deactivation_hook(__FILE__, array($class, 'deactivate'));

        // Admin actions
        add_action('admin_init', array($class, 'adminInit'));
        add_action('admin_init', array($class, 'autoCheckUpdates'));
        add_action('admin_menu', array($class, 'adminMenu'));
        add_action('wp_ajax_' . self::PREFIX, array($class, 'adminAjax'));
        add_action('admin_enqueue_scripts', array($class, 'adminEnqueueResources'));

        // Frontend actions
        add_action('wp_print_styles',  array($class, 'wpPrintStyles'));
        add_action('wp_enqueue_scripts',  array($class, 'wpEnqueueScripts'));
        add_action('save_post', array($class, 'savePost'), 10, 2);

        // Post filter actions
        if (!is_admin()) {
            if (self::checkUrl()) {
                add_filter('wp_loaded', array($class, 'filterUrl'));
            } else {
                add_filter('the_post', array($class, 'preFilterContent'));
                add_filter('the_content', array($class, 'filterContent'));
            }
        }

        self::addLibraryIncludePath();
    }

    /**
    * Plug-in activate hook
    */
    static public function activate($networkWide)
    {
        global $wpdb;

        self::loadApplication();
        if ($networkWide) {
            $siteIds = $wpdb->get_col("SELECT `blog_id` FROM `{$wpdb->blogs}`");
            foreach ($siteIds as $siteId) {
                switch_to_blog($siteId);
                self::_activateInstall();
                restore_current_blog();
            }
        } else {
            self::_activateInstall();
        }
    }

    static protected function _activateInstall()
    {
        Ali_Application::getService('Setup')->install();
    }

    /**
    * Plug-in deactivation hook
    */
    static public function deactivate()
    {

    }

    static public function addLibraryIncludePath()
    {
        $includePaths = explode(PATH_SEPARATOR, get_include_path());
        $path = realpath(dirname(__FILE__) . '/library');
        if (!in_array($path, $includePaths)) {
            foreach ($includePaths as $key=>$item) {
                if ('.' == $item) {
                    unset($includePaths[$key]);
                    break;
                }
            }
            array_unshift($includePaths, $path);
            array_unshift($includePaths, '.');
            set_include_path(implode(PATH_SEPARATOR, $includePaths));
        }
    }

     static public function adminInit()
     {
         /*
         if (!session_id()) {
                session_start();
         }
         */
     }

     static public function autoCheckUpdates()
    {
        $updater = self::$_updater;
        $state = $updater->getUpdateState();

        $shouldCheck = (empty($state)
            || !isset($state->lastCheck)
            || ((time() - $state->lastCheck) >= (self::UPDATE_CHECK_UNTERVAL * 3600)))
            && !wp_next_scheduled(self::$_updaterCronHook);

        if ($shouldCheck) {
            wp_schedule_single_event(time(), self::$_updaterCronHook);
            spawn_cron();
        }
    }

    /**
    * admin_menu hook
    */
    static public function adminMenu()
    {
        $inst = self::getInstance();

        $inst->_registerAdminPages();
        $inst->_registerMetaboxes();
    }

    static public function adminAjax()
    {
        self::getInstance()->dispatchAjax();
    }

    static public function savePost($postId, $post)
    {
        // Ignore new posts, autosave and revisions:
        if (wp_is_post_autosave($postId)
            || wp_is_post_revision($postId)
            || 'auto-draft' == $post->post_status
            || 'trash' == $post->post_status
            || (isset($_POST['action']) && 'autosave' == $_POST['action'])
            || 'nav_menu_item' == $post->post_type
        ) {
            return;
        }
        if (isset($_POST[self::PREFIX . '_metabox'])
            && is_array($_POST[self::PREFIX . '_metabox'])
        ) {
            self::getInstance()->dispatch__metabox__handle_save_post($postId,
                $_POST[self::PREFIX . '_metabox']);
        }
    }

    static public function adminEnqueueResources($hook)
    {
        if (!in_array($hook, array(
            'toplevel_page_' . self::SLUG,
            'post.php',
            'post-new.php'))
        ) {
            return;
        }

        wp_enqueue_script(self::SLUG . '-admin',
            self::getPluginBaseUrl() . '/js/admin.js',
            array('jquery'),
            self::VERSION);

        wp_enqueue_style(self::SLUG . '-admin',
            self::getPluginBaseUrl() . '/css/admin.css',
            array(),
            self::VERSION);
    }

    /**
    * wp_print_styles hook
    */
    static public function wpPrintStyles()
    {
        /*wp_enqueue_style(self::PREFIX . '/post.css',
            self::getInstance()->getPluginBaseUrl() . '/template/post.css',
            array(),
            date('YmdHis', filemtime(dirname(__FILE__) . '/template/post.css')));*/
    }

    /**
    * wp_enqueue_scripts hook
    */
    static public function wpEnqueueScripts()
    {

    }

    static public function preFilterContent($post)
    {
        self::loadApplication();
        $service = Ali_Application::getService('Linker')
            ->setPost($post);

        return $post;
    }

    static public function filterContent($content)
    {
        self::loadApplication();
        return $service = Ali_Application::getService('Linker')
            ->filterContent($content);
    }

    static public function filterUrl()
    {
        self::loadApplication();

        $service = Ali_Application::getService('Linker')
            ->redirect(self::$_keywordSlug);
    }

    static public function checkUrl()
    {
        $path = explode('/', substr($_SERVER['REQUEST_URI'], strlen(self::getHomePath())));

        if ('index.php' == $path[0]) {
            array_shift($path);
        }

        if (2 != count($path)
            || get_option(self::PREFIX . '_dir_path', NULL) !== $path[0]
            || '' == $path[1]
        ) {
            return FALSE;
        }

        self::$_keywordSlug = $path[1];

        return TRUE;
    }

    static public function getHomePath()
    {
         return trailingslashit((string) parse_url(site_url(), PHP_URL_PATH));
    }

    static public function loadApplication()
    {
        self::addLibraryIncludePath();
        require_once(self::$_pluginPath . '/application/Application.php');
    }

    /**
    * Singleton pattern
    *
    * @return Ali_WpPlugin Singleton instance
    */
    static public function getInstance()
    {
        if (!self::$_instance) {
            self::$_instance = new self;
        }

        return self::$_instance;
    }

    static public function getPluginBaseUrl()
    {
        return self::$_pluginBaseUrl;
    }

    static public function getPluginPath()
    {
        return self::$_pluginPath;
    }

//------------------------------------------------------------------------------
// Object members
//------------------------------------------------------------------------------

    /**
    * Register plug-in admin pages and menus
    */
    protected function _registerAdminPages()
    {
        add_menu_page(self::TITLE, self::MENU_LABEL,
            self::CAPABILITY, self::SLUG,
            array($this, 'dispatchAdmin'),
            self::getPluginBaseUrl() . '/images/icon.png'
        );

        add_submenu_page(self::SLUG, self::TITLE,
            'Admin', self::CAPABILITY,
            self::SLUG,
            array($this, 'dispatchAdmin')
        );

        add_submenu_page(self::SLUG, self::TITLE,
            'Tracking Stats', self::CAPABILITY,
            self::SLUG . '-stats',
            array($this, 'dispatch__stats')
        );
        add_action('admin_head-' . self::ADMIN_SLUG . '_page_' . self::SLUG . '-stats',
            array($this, 'dispatch__admin__head'));
    }

    protected function _registerMetaBoxes()
    {
        $postTypes = get_post_types(array('show_ui' => TRUE, 'show_in_nav_menus' => TRUE));

        foreach($postTypes as $type) {
            add_meta_box(self::PREFIX . '_main',
                self::TITLE, array($this, 'dispatch__metabox__index'), $type,
                'side', 'high');
        }
    }

    /**
    * Intercepts WP requests
    */
    public function __call($method, $arguments)
    {
        if ('dispatch__' == substr($method, 0, 10)) {
            $parts = explode('__', $method);
            $controller = @$parts[1];
            $action = @$parts[2];

            $controller = $this->_prepareMvcName($controller);
            $action = $this->_prepareMvcName($action);

            $this->dispatch($controller, $action, $arguments);
        }
        else {
            throw new Exception("Method {$method} not found.");
        }
    }

    protected function _prepareMvcName($name)
    {
        return str_replace('_', '-', $name);
    }

    /**
    * Dispatches user request to WP Module
    *
    * @param string $controller Controller name
    * @param string $action Action name
    */
    public function dispatch($controller='index', $action='index',
        $params = NULL)
    {
        self::loadApplication();
        Ali_Application::dispatch($controller, $action, $params);
    }

    public function dispatchAdmin()
    {
        $controller = @$_GET['controller'];
        if (empty($controller)) {
            $controller = 'admin';
        }
        $action = @$_GET['action'];
        if (empty($action)) {
            $action = 'index';
        }

        $this->dispatch($controller, $action);
    }

    public function dispatchAjax()
    {
        $controller = @$_POST['controller'];
        if (empty($controller)) {
            $controller = 'index';
        }
        $action = @$_POST['controller_action'];
        if (empty($action)) {
            $action = 'index';
        }

        $this->dispatch($controller, $action);

        exit();
    }
}